library BFmIRC;

uses
  Windows,
  SysUtils,
  Classes,
  Blowfish,
  Base64;

{$R *.res}

function BFEncrypt(const Key, Source: String): PAnsiChar;
var
  bfCrypt:  TDCP_Blowfish;
  pResult:  String;
begin
  SetLength(pResult, Length(Source));
  bfCrypt := TDCP_Blowfish.Create(nil);
  bfCrypt.InitStr(Key);
  bfCrypt.EncryptCBC(Source[1], pResult[1], Length(Source));
  bfCrypt.Reset();
  bfCrypt.Burn();
  bfCrypt.Free();
  Result  := PAnsiChar(B64Encode(pResult));
end;

function BFDecrypt(const Key, Source: String): PAnsiChar;
var
  bfCrypt:  TDCP_Blowfish;
  pResult:  String;
begin
  pResult := B64Decode(Source);
  bfCrypt := TDCP_Blowfish.Create(nil);
  bfCrypt.InitStr(Key);
  bfCrypt.DecryptCBC(pResult[1], pResult[1], Length(pResult));
  bfCrypt.Reset();
  bfCrypt.Burn();
  bfCrypt.Free();
  Result  := PAnsiChar(pResult);
end;

function StrGetWord(a: AnsiString; b: Integer; c: Boolean): String;
var
  i,j: Integer;
begin
  a:=Trim(StringReplace(a,#32#32,#32,[rfReplaceAll]));
  j:=0;
  for i:=1 to Length(a) do
  begin
    if (a[i] = #32) then
    begin
      inc(j);
      if (j = b) and not c then Break;
      if (j < b) then Result:=''
      else Result:=Result+a[i];
    end
    else begin
      Result:=Result+a[i];
    end;
  end;
end;

function Encrypt(mWnd, aWnd: HWND; data, parms: PChar; show, nopause:boolean):integer; stdcall;
var
  S: PAnsiChar;
begin
  try
    S:=BFEncrypt(StrGetWord(data,1,False),StrGetWord(data,2,True));
    StrCopy(data,S);
    Result := 3;
  except
    on E: Exception do Result := 1;
  end;

end;

function Decrypt(mWnd, aWnd: HWND; data, parms: PChar; show, nopause:boolean):integer; stdcall;
var
  S: PAnsiChar;
begin
  try
    S:=BFDecrypt(StrGetWord(data,1,False),StrGetWord(data,2,True));
    StrCopy(data,S);
    Result := 3;
  except
    on E: Exception do Result:=1;
  end;
end;

function DLLInfo(mWnd, aWnd: HWND; data, parms: PChar; show, nopause:boolean):integer; stdcall;
begin
  StrCopy(data,'BlowFish + Base64 Encryption DLL for mIRC, by Frozen - irc.renegadeirc.net');
  Result := 3;
end;

Exports
  Encrypt,
  Decrypt,
  DLLInfo;

begin
end.
 
